﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace AsynchronerAufruf_3
{
    class Program
    {
        static void Main(string[] args)
        { 
            Mathematics math = new Mathematics();
            int value = 23;
            AsyncCallback callback = new AsyncCallback(CallbackMethod);
            // Aufruf der asynchronen Ausführung
            math.BeginCalculate(value, callback, math);
            for (int i = 0; i <= 100; i++)
            {
                Console.Write(".{0}.", i);
                Thread.Sleep(5);
            }
            Console.ReadLine();
        }

        // diese Methode wird vom Server aufgerufen
        public static void CallbackMethod(IAsyncResult ar)
        {
            Mathematics math = (Mathematics)ar.AsyncState;
            // das Ergebnis der asynchronen Operation abholen
            int result = math.EndCalculate(ar);
            Console.Write("---Resultat = {0} ", result);
            Console.Write("---FERTIG---");
        }
    }

    class Mathematics
    {
        private delegate int CalculateHandler(int x);
        CalculateHandler del;

        // Methode Calculate wird synchron ausgeführt
        public int Calculate(int x)
        {
            Console.Write("---Bearbeitung startet---");
            for (int i = 0; i <= 20; i++)
            {
                Console.Write("X");
                Thread.Sleep(10);
            }
            Console.Write("---Bearbeitung beendet---");
            return x * x;
        }

        // Start der asynchronen Ausführung
        public IAsyncResult BeginCalculate(int intVar,  AsyncCallback callback, object state)
        {
            del = new CalculateHandler(Calculate);
            // Aufruf der Methode Calculate, die in einem eigenen Thread ausgeführt wird
            return del.BeginInvoke(intVar, callback, state);
        }

        // Beenden der asynchronen Ausführung
        public int EndCalculate(IAsyncResult asyncResult)
        {
            return del.EndInvoke(asyncResult);
        }
    }

}
