﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace AusgabeModifizierterDaten
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection con = new SqlConnection();
            con.ConnectionString = @"Data Source=.\sqlexpress;Database=Northwind;Integrated Security=true";
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = con;
            cmd.CommandText = "SELECT ProductID, ProductName, UnitsInStock " +
                              "FROM Products";
            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.FillSchema(ds, SchemaType.Source);
            ds.Tables[0].Columns["ProductID"].AutoIncrementSeed = -1;
            ds.Tables[0].Columns["ProductID"].AutoIncrementStep = -1;
            da.Fill(ds);
            // Neue Datenzeile hinzufügen
            DataRow newRow = ds.Tables[0].NewRow();
            newRow["ProductName"] = "Camembert";
            newRow["UnitsInStock"] = 100;
            ds.Tables[0].Rows.Add(newRow);
            // Datenzeile ändern
            DataRow[] editRow = ds.Tables[0].Select("ProductName='Tofu'");
            if (editRow.Length == 1)
            {
                editRow[0].BeginEdit();
                editRow[0]["UnitsInStock"] = 1000;
                editRow[0].EndEdit();
            }
            else
                Console.WriteLine("Datenzeile 'Tofu' nicht gefunden.");
            // Datenzeile löschen
            ds.Tables[0].Rows[4].Delete();
            // Ausgabe
            foreach (DataRow tempRow in ds.Tables[0].Rows)
            {
                if (tempRow.RowState == DataRowState.Added)
                    Console.WriteLine("Neue Datenzeile: {0}", tempRow["Productname"]);
                else if (tempRow.RowState == DataRowState.Modified)
                {
                    Console.WriteLine("Modifiziert: {0}", tempRow["Productname"]);
                    Console.WriteLine("Alter Wert: {0}",
                               tempRow["UnitsInStock", DataRowVersion.Original]);
                    Console.WriteLine("Neuer Wert: {0}", tempRow["UnitsInStock"]);
                }
                else if (tempRow.RowState == DataRowState.Deleted)
                    Console.WriteLine("Gelöscht: {0}",
                         tempRow["ProductName", DataRowVersion.Original]);
                else
                    continue;
                Console.WriteLine(new string('-', 40));
            }
            Console.ReadLine();

        }
    }
}
