﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace ManuelleAktualisierung
{
    class Program
    {
        static DataSet dsConflict = new DataSet();
        static SqlDataAdapter daConflict = new SqlDataAdapter();
        static SqlConnection con = new SqlConnection();

        static void Main(string[] args)
        {            
            con.ConnectionString = @"Data Source=.\sqlexpress;Database=Northwind;Integrated Security=true";
            SqlCommand cmd = new SqlCommand();
            cmd.CommandText = "SELECT ProductID, ProductName, Unitprice, UnitsInStock, Discontinued FROM Products";
            cmd.Connection = con;

            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            SqlCommandBuilder cmb = new SqlCommandBuilder(da);
            da.UpdateCommand = CreateUpdateCommand(con);
            da.FillSchema(ds, SchemaType.Source);
            ds.Tables[0].Columns[0].AutoIncrementSeed = -1;
            ds.Tables[0].Columns[0].AutoIncrementStep = -1;
            da.Fill(ds);

            // Datenzeilen ändern
            ChangeDataRows(ds);

            // Datenzeilen hinzufügen
            AddDataRows(ds);

            // Simulation eines Konflikts
            Console.Write("Konflikt simulieren ...");
            Console.ReadLine();

            // Datenbank aktualisieren
            da.ContinueUpdateOnError = true;
            da.RowUpdated += new SqlRowUpdatedEventHandler(da_RowUpdated);
            da.Update(ds);
            // Konflikt-DataSet abrufen
            if (dsConflict.Tables.Count > 0)
            {
                Console.WriteLine("\n{0,-5}{1,-35}{2,-12}{3}", "ID", "ProductName", "UnitPrice", "UnitsInStock");
                Console.WriteLine(new string('-', 65));
                foreach (DataRow item in dsConflict.Tables[0].Rows)
                    Console.WriteLine("{0,-5}{1,-35}{2,-12}{3}", item["ProductID"], item["ProductName"], item["UnitPrice"], item["UnitsInStock"]);
            }            
            Console.ReadLine();
        }

        static void da_RowUpdated(object sender, SqlRowUpdatedEventArgs e)
        {
            if (e.Status == UpdateStatus.ErrorsOccurred)
            {
                SqlCommand cmdConflict = new SqlCommand();
                string sql = "SELECT ProductID, ProductName, UnitPrice, UnitsInStock FROM Products WHERE ProductID = " + e.Row["ProductID"];
                cmdConflict = new SqlCommand();
                cmdConflict.Connection = con;
                cmdConflict.CommandText = sql;
                daConflict.SelectCommand = cmdConflict;
                int result = daConflict.Fill(dsConflict);

                if (e.Errors.GetType() == typeof(SqlException)) {
                    // Prüfen, ob es einen DS mit einem bestimmten PS gibt
                    if (result == 1)
                        Console.WriteLine("Der PS existiert bereits.");
                }
                else if (e.Errors.GetType() == typeof(DBConcurrencyException)) {
                    // ist Anzahl=1 -> anderer Benutzer hat DS geändert
                    if (result == 1)
                        Console.WriteLine("Ein anderer User hat den Datensatz geändert.");
                    else
                        Console.WriteLine("Datensatz existiert nicht in der Datenbank.");
                }
            }
        }


        static SqlCommand CreateUpdateCommand(SqlConnection con)
        {
            string sql = "UPDATE Products SET ProductName=@p1, UnitPrice=@p2, UnitsInStock=@p3 WHERE ProductID=@p4 AND ProductName= @p5 AND UnitPrice=@p6";

            SqlCommand cmd = new SqlCommand(sql, con);
            cmd.Parameters.Add("@p1", SqlDbType.VarChar, 40, "ProductName");
            cmd.Parameters.Add("@p2", SqlDbType.Money, 8, "UnitPrice");
            cmd.Parameters.Add("@p3", SqlDbType.SmallInt, 2, "UnitsInStock");
            cmd.Parameters.Add("@p4", SqlDbType.Int, 4, "ProductID");

            SqlParameter param;
            param = cmd.Parameters.Add("@p5", SqlDbType.VarChar, 40, "ProductName");
            param.SourceVersion = DataRowVersion.Original;

            param = cmd.Parameters.Add("@p6", SqlDbType.Money, 8, "UnitPrice");
            param.SourceVersion = DataRowVersion.Original;
            return cmd;
        }

        static void ChangeDataRows(DataSet ds)
        {
            ds.Tables[0].Rows[0]["ProductName"] = "Pfeffer";
            ds.Tables[0].Rows[1]["Productname"] = "Salz";
            ds.Tables[0].Rows[2]["Productname"] = "Banane";
            ds.Tables[0].Rows[3]["Productname"] = "Orange";
            ds.Tables[0].Rows[4]["Productname"] = "Mango";
            ds.Tables[0].Rows[5]["UnitsInStock"] = 125;
            ds.Tables[0].Rows[6]["UnitsInStock"] = 55;
        }

        static void AddDataRows(DataSet ds)
        {
            DataRow row1 = ds.Tables[0].NewRow();
            row1["Productname"] = "Suppenhuhn";
            row1["Discontinued"] = 0;
            ds.Tables[0].Rows.Add(row1);
            DataRow row2 = ds.Tables[0].NewRow();
            row2["Productname"] = "Aachener Printe";
            row2["Discontinued"] = 0;
            ds.Tables[0].Rows.Add(row2);
        }
    }
}
