﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// In diesem Programm wird anhand von 'Starten()' gezeigt, wie eine geerbte virtuelle Methode 
// mit dem Modifizierer 'new' überdeckt oder mit 'override' überschrieben wird wird
namespace Sample3
{
  class Program
  {
    static void Main(string[] args)
    {
      Flugzeug flg = new Flugzeug();
      flg.Starten();
      Hubschrauber hubi = new Hubschrauber();
      hubi.Starten();
      Console.ReadLine();
    }
  }

  class Luftfahrzeug
  {
    public string Hersteller { get; set; }
    public int Baujahr { get; set; }

    // virtuelle Methode
    public virtual void Starten()
    {
      Console.WriteLine("Das Luftfahrzeug startet.");
    }
  }

  class Flugzeug : Luftfahrzeug
  {
    public double Spannweite { get; set; }

    // Überdecken einer virtuellen Methode
    public new void Starten()
    {
      Console.WriteLine("Das Flugzeug startet.");
    }
  }

  class Hubschrauber : Luftfahrzeug
  {
    public double Rotor { get; set; }

    // Überschreiben einer virtuellen Methode
    public override void Starten()
    {
      Console.WriteLine("Der Hubschrauber startet.");
    }
  }
}



