﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GeometricObjects
{
  public abstract class GeometricObject
  {
      // Statisches Feld
      private static int _CountGeometricObjects;

      public static int CountGeometricObjects
      {
          get { return _CountGeometricObjects; }
      }

      // Konstruktor
      protected GeometricObject()
      {
          GeometricObject._CountGeometricObjects++;
      }


    // Felder
    public virtual double XCoordinate { get; set; }
    public virtual double YCoordinate { get; set; }

    // Abstrakte Methoden
    public abstract double GetArea();
    public abstract double GetCircumference();

    // Instanzmethoden
    public virtual int Bigger(GeometricObject @object)
    {
      if (GetArea() < @object.GetArea()) return -1;
      if (GetArea() == @object.GetArea()) return 0;
      return 1;
    }

    public virtual void MoveXY(double dx, double dy)
    {
      XCoordinate += dx;
      YCoordinate += dy;
    }

    // Klassenmethode
    public static int Bigger(GeometricObject object1, GeometricObject object2)
    {
      if (object1.GetArea() < object2.GetArea()) return -1;
      if (object1.GetArea() == object2.GetArea()) return 0;
      return 1;
    }
  }
}    
