﻿using System;
using System.Collections;

namespace IComparerSample
{
    class Program
    {

        static void Main(string[] args)
        {
            ArrayList arrList = new ArrayList();
            // ArrayList füllen
            Person pers1 = new Person { Name = "Meier", City = "Berlin" };
            arrList.Add(pers1);
            Person pers2 = new Person { Name = "Arnhold", City = "Köln" };
            arrList.Add(pers2);
            Person pers3 = new Person { Name = "Graubär", City = "Aachen" };
            arrList.Add(pers3);
            // nach Cities sortieren
            arrList.Sort(new CityComparer());
            Console.WriteLine("Liste nach Wohnorten sortiert");
            ShowSortedList(arrList);
            // nach Namen sortieren
            arrList.Sort(new NameComparer());
            Console.WriteLine("Liste nach Namen sortiert");
            ShowSortedList(arrList);
            Console.ReadLine();
        }

        static void ShowSortedList(IList liste)
        {
            foreach (Person temp in liste)
            {
                Console.Write("Name = {0,-12}", temp.Name);
                Console.WriteLine("Wohnort = {0}", temp.City);
            }
            Console.WriteLine();
        }
    }

    // Vergleichsklasse – Kriterium City
    class CityComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            // prüfen auf null-Übergabe
            if (x == null && y == null) return 0;
            if (x == null) return -1;
            if (y == null) return 1;
            // Typüberprüfung
            if (x.GetType() != y.GetType())
                throw new ArgumentException("Ungültiger Vergleich");
            // Vergleich
            return ((Person)x).City.CompareTo(((Person)y).City);
        }
    }
    // Vergleichsklasse – Kriterium Name
    class NameComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            // prüfen auf null-Übergabe
            if (x == null && y == null) return 0;
            if (x == null) return -1;
            if (y == null) return 1;
            // Typüberprüfung
            if (x.GetType() != y.GetType())
                throw new ArgumentException("Ungültiger Vergleich");
            // Vergleich
            return ((Person)x).Name.CompareTo(((Person)y).Name);
        }
    }


    class Person
    {
        public string Name { get; set; }
        public string City { get; set; }
    }


}